/***********************************************************************************************************************
 * Copyright (C) All rights reserved.
 ***********************************************************************************************************************/

/***********************************************************************************************************************
* @file    hal_rng.h
* @brief   This file implements device driver for RNG module.
* @version 1.0.0
* @date    2022/09/24
***********************************************************************************************************************/
#ifndef RNG_H
#define RNG_H

#include "stdint.h"

/***********************************************************************************************************************
Macro definitions (Register bit)
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/
typedef enum
{
    TRNGCKS_CKS_DIV_1,
    TRNGCKS_CKS_DIV_2,
    TRNGCKS_CKS_DIV_4,
    TRNGCKS_CKS_DIV_8,
    TRNGCKS_CKS_DIV_16,
    TRNGCKS_CKS_DIV_32,
    TRNGCKS_CKS_DIV_64,
    TRNGCKS_CKS_DIV_128
} trng_div_t;

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
extern void TRNG_Init(trng_div_t div_cnt);
extern void TRNG_DeInit(void);
extern uint32_t TRNG_GetRandomNumber(void);
/* Start user code for function. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#endif
