/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : 
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;

extern void SysTick_Handler(void);
static void delayMS(uint32_t n);

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks){}
}

int main()
{
	uint32_t msCnt; 	// count value of 1ms
    //uint32_t i;
    //__EI;

//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	g_ticks = 1000; 	// 1000ms
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 

//-----------------------------------------------------------------------
// LED blinky on target board 
// P71 and P72 drives LED on EVB
//----------------------------------------------------------------------- 
	PORT->PC    = 0x40U;
	PORT->PMC  &= ~(3<<5); // PC05/LED, PC05/LED

	while(1)
	{
		delayMS(250);
        //for(i=0; i<1000000; i++){ }  			// delay 60ms
		PORT->PC ^= (3<<5); 	// Toggle PC05, PC06

	}
}

/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
    NVIC_ClearPendingIRQ(SysTick_IRQn);
	g_ticks--;
	WDT->WDTE = 0xAC;
	IWDT->WDTE = 0xAC;
}

