/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : 
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "sci.h"
#include "isr.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;

extern void SysTick_Handler(void);
static void delayMS(uint32_t n);

extern void uart0_interrupt_receive(void);
extern void uart0_interrupt_send(void);

const uint8_t helloword[] = {"Cmsemicon BAT32G439 Uart0 test!\r\n"};
const uint8_t buf[256];
void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks){}
}

int main()
{
	uint32_t msCnt; 	// count value of 1ms
  
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	g_ticks = 1000; 	// 1000ms
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 

//-----------------------------------------------------------------------
// uart0 init
//----------------------------------------------------------------------- 
	UART_Init(SCI0, SystemCoreClock, 115200);
	UART_Start(SCI0);
//	ISR_Register(SR0_IRQn, uart0_interrupt_receive);
//	ISR_Register(ST0_IRQn, uart0_interrupt_send);

	NVIC_ClearPendingIRQ(ST0_IRQn);
	NVIC_EnableIRQ(ST0_IRQn);
	NVIC_ClearPendingIRQ(SR0_IRQn);
	NVIC_EnableIRQ(SR0_IRQn);
	while(1)
	{
		delayMS(500);
		UART_Send_Int(SCI0, helloword, sizeof(helloword));
//		UART_Receive_Int(SCI0, buf, 5);	
//		UART_Send_Int(SCI0, buf, 5);		
	}
}

/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
  
	g_ticks--;
//	WDT->WDTE = 0xAC;
//	IWDT->WDTE = 0xAC;
}

