/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/
#pragma clang diagnostic ignored "-Wunused-parameter"
#pragma clang diagnostic ignored "-Wunused-variable"

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "adc.h"
#include "sci.h"
#include "clk.h"

#define ADTSTRC0	    *((volatile uint16_t *)(0x40091400UL + 0x6E))
#define ADTSTRC1	    *((volatile uint16_t *)(0x40091800UL + 0x6E))
#define ADTSTRC2	    *((volatile uint16_t *)(0x40091C00UL + 0x6E))
#define ADTSTPR0	    *((volatile uint8_t  *)(0x40091400UL + 0x63))
#define ADTSTPR1	    *((volatile uint8_t  *)(0x40091800UL + 0x63))
#define ADTSTPR2	    *((volatile uint8_t  *)(0x40091C00UL + 0x63))

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;
void SysTick_Handler(void);
void delayMS(uint32_t n);

static double voltage=4.98;
static uint16_t get_value[8];

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}


int main()
{
	uint32_t msCnt; 	// count value of 1ms
	MD_STATUS status;
	uint32_t i;
    uint16_t * pBuf;
	
//-----------------------------------------------------------------------
// fIH=16MHz (Option Byte(402H) = 0xEA)
//-----------------------------------------------------------------------
    //fPLL=128MHz	
    CLK_PLL_Setting(PLL_SR_fIH,PLL_DIV_2,PLL_MUL_16);
    CLK_PLL_Start();
    CLK_Fclk_Select(MAINCLK_FPLL);
    while((CGC->MCKC & 0x80) == 0x00);	        //wait for CKSTR = 1

//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	g_ticks = 1000; 	// 1000ms
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 

//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#if 1
	SystemCoreClockUpdate();
	status = UART_Init(SCI0, SystemCoreClock, 19200);
	if(status == MD_ERROR)
	{
		while(1);
	}
	printf("Hello, UART\n");
#endif

	adc_initial(ADC0,0xFF);//ADCx_CH0+ADCx_CH2);
    ADTSTPR0=0x03;
    ADTSTRC0=0x0010;
    adc_software_start(ADC0);

	adc_initial(ADC1,0xFF);//ADCx_CH2);
    ADTSTPR1=0x03;
    ADTSTRC1=0x0010;
    adc_software_start(ADC1);

	adc_initial(ADC2,0xFFFF);//ADCx_CH14);
    ADTSTPR2=0x03;
    ADTSTRC2=0x0010;
    adc_software_start(ADC2);

    if (g_adc_refresh_flag.bit.req_adc0){
        for(i=0;i<8;i++){
            printf("ANI0%02d=%03x, vol=%2.3fV\n",i,adc0_buf[i],adc0_buf[i]*voltage/4096);
        }
        g_adc_refresh_flag.bit.req_adc0 = 0;        // clear req
    }
    if (g_adc_refresh_flag.bit.req_adc1){
        for(i=0;i<8;i++){
            printf("ANI1%02d=%03x, vol=%2.3fV\n",i,adc1_buf[i],adc1_buf[i]*voltage/4096);
        }
        g_adc_refresh_flag.bit.req_adc1 = 0;        // clear req
    }
    if (g_adc_refresh_flag.bit.req_adc2){
        for(i=0;i<16;i++){
            printf("ANI2%02d=%03x, vol=%2.3fV\n",i,adc2_buf[i],adc2_buf[i]*voltage/4096);
        }
        g_adc_refresh_flag.bit.req_adc2 = 0;        // clear req
    }

    PORT->PMC  &= ~0x4800;  // PC14,PC11 output mode
    while(1){
        delayMS(500);
        PORT->PSETC = 0x4800;   // PC14,PC11 output "H"
        delayMS(500);
        PORT->PCLRC = 0x4800;   // PC14,PC11 output "L"
    }
}

/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}

