/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/12/25
***********************************************************************************************************************/
#pragma clang diagnostic ignored "-Wcast-align"
#pragma clang diagnostic ignored "-Wsign-conversion"
#pragma clang diagnostic ignored "-Wimplicit-int-conversion"
#pragma clang diagnostic ignored "-Wmissing-variable-declarations"

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "clk.h"
#include "sci.h"
#include "aes.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;
AES_InitTypeDef AESInitStruct;
void SysTick_Handler(void);
void delayMS(uint32_t n);

uint8_t encryptdata[16] = 
{
	0x44,0x03,0x77,0x10,0x23,0x20,0x23,0x01,0x13,0x05,0x12,0x34,0x56,0x78,0x9a,0xbc,
};
uint8_t ivdata[32] =
{
	"g439 aestestivdata",
};
uint8_t keydata[32] =
{
	"CMSemicon Bat32g439 AES test key",
};

uint8_t decryptdata[16];
uint8_t testdata[16]; 


void hard_fault_handler_c(unsigned int * hardfault_args, unsigned lr_value);

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks){}
}



int main()
{
	MD_STATUS status;
	
//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#if 0
	SystemCoreClockUpdate();
	status = UART_Init(SCI0, SystemCoreClock, 19200);
	if(status == MD_ERROR)
	{
		while(1);
	}
	
	printf("Hello, UART\n");
#endif

#if 0
//-----------------------------------------------------------------------
// MainOSC and SubOSC enable
//-----------------------------------------------------------------------
	//CLK_Osc_Setting(OSC_EXCLK, OSC_EXCLK);
	CLK_MainOsc_Setting(OSC_OSCILLATOR, MOSC_DIV_1);
	CLK_SubOsc_Setting(OSC_OSCILLATOR, OSC_LOW_POWER);

//-----------------------------------------------------------------------
// Select PLL as system clock
//-----------------------------------------------------------------------
  CLK_PLL_Setting(PLL_SR_fMX,PLL_DIV_1,PLL_MUL_16);
	CLK_PLL_Start();
	CLK_Fclk_Select(MAINCLK_FPLL);
	while((CGC->MCKC & CGC_MCKC_CKSTR_Msk) == 0);
#endif

  SystemCoreClock = 64000000;//128000000;        // PLL clock = 128MHz
	
	SysTick_Config(SystemCoreClock/1000);//1ms
	
	
	status = UART_Init(SCI0, SystemCoreClock, 19200);
	printf("BAT32G439 AES Test!\n");
	
//	AESInitStruct.run_mode = ENCRYPT_MODE;
	AESInitStruct.encrypt_mode = AES_ECB_MODE;
	AESInitStruct.key_length = KEY_LENGTH_256;
	AESInitStruct.pIVdata = (uint32_t*)ivdata;
	AESInitStruct.pKeydata = (uint32_t*)keydata;
	
	AES_Init(&AESInitStruct);
	
  while(1)
	{
		delayMS(500);
		
		AES_Encrypt(&AESInitStruct,encryptdata,decryptdata);
		
		AES_Decrypt(&AESInitStruct,decryptdata,testdata);
		
	}

}
/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	NVIC_ClearPendingIRQ(SysTick_IRQn);

	g_ticks--;
}


