/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "sci.h"
#include "dac.h"
#include "cmp.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
volatile uint32_t g_ticks;

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}

void CMP0_Init(void)
{
	CMP_InitTypeDef CMPInitStruct = {0};
	
	CMPInitStruct.edge_select = CMP_EDGE_FALLING;
	CMPInitStruct.filter_select = CMP_FILTER_NONE;
	CMPInitStruct.pside_select = CMP_PSIDE_VCIN0;//positive input:PA00
	CMPInitStruct.nside_select = CMP_NSIDE_VREF0;//PB08	CMP_NSIDE_VREF3: negative input:DAC0
	CMPInitStruct.hysteresis_select = CMP_HYS_BOTH;
	CMPInitStruct.hysteresis_voltage = CMP_HYS_40MV;
	CMPInitStruct.interrupt_enable = 1;//enable cmp0 interrupt
	CMPInitStruct.vcout_enable = 1;//enable cmp output
	
	CMP_Init(CMP0, &CMPInitStruct);
	CMP_Start(CMP0);
	
}

int main()
{
	MD_STATUS status;
	uint32_t msCnt; 	// count value of 1ms
	uint32_t i, j;

//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------
	g_ticks = 1000;
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt);  
	
//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#if 1
	SystemCoreClockUpdate();
	status = UART_Init(SCI0, SystemCoreClock, 115200);//115200bps
	if(status == MD_ERROR)
	{
		while(1);
	}

	printf("Hello, CMP Test!\n");
#endif

//-----------------------------------------------------------------------
// DAC channel 0 output --> CMP channel 0 negative side input
//-----------------------------------------------------------------------
	
	DAC_Init(DAC0);
	DAC_SetValue(DAC0, 0x40);
//	DAC_Start(DAC0);
	
	DAC_Init(DAC1);
	DAC_SetValue(DAC1, 0xA0);
	DAC_Start(DAC1);

	CMP0_Init();
	
	while(1)
	{
		
	}
}
/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}
