/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "sci.h"
#include "iica.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;
void SysTick_Handler(void);
void delayMS(uint32_t n);
static uint8_t tx_buf[3];
static uint8_t rx_buf[3];

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}


int main()
{
	MD_STATUS status;
	uint32_t err;
	uint32_t i;
	
//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#if 1
	SystemCoreClockUpdate();
	status = UART_Init(SCI0, SystemCoreClock, 19200);
	if(status == MD_ERROR)
	{
		while(1);	// The baud rate cannot get at the current system clock frequency.
	}
	
	printf("Hello, UART\n");
#endif

//-----------------------------------------------------------------------
// IICA Single Master transmission/reception
//----------------------------------------------------------------------- 
#if 1
	printf("\n");	
	printf("Please connect No.34 pin(PD00/SCLA0) to SCL on partner board\n");
	printf("Please connect No.33 pin(PD01/SDAA0) to SDA on partner board\n");
//	printf("Press any key to continue\n");
//	getchar();
//	printf("\n");	
#endif

    IICA0_Init();
	tx_buf[0] = 0xAA;
	tx_buf[1] = 0x55;
	tx_buf[2] = 0x5A;
	
	status = IICA0_MasterSend(SLVADDR, tx_buf, 3, 20);
	while(g_iica0_tx_end == 0);

	status = IICA0_MasterReceive(SLVADDR, rx_buf, 3, 20);
	while(g_iica0_rx_end == 0);
	
	/***********************************************************************
	*  Compare the reveived value with sent value
	*  tx_buf[0] == rx_buf[0]
	*  tx_buf[1] == rx_buf[1]
	*  tx_buf[2] == rx_buf[2]
	***********************************************************************/
	err = 0;
	for(i=0; i<sizeof(tx_buf); i++)
	{
		if(tx_buf[i] != rx_buf[i])
		{
			err = 1;
		}
	}
#if 1
	if(err)
	{
		printf("IICA0 Send and Receive NG\n");
	}
	else
	{
		printf("IICA0 Send and Receive OK\n");
	}

#endif
}
/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}


