/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "sci.h"
#include "iica.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;
void SysTick_Handler(void);
void delayMS(uint32_t n);
static uint8_t buf[256];
void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}


int main()
{
	MD_STATUS status;
//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#if 0
	SystemCoreClockUpdate();
	status = UART_Init(SCI0, SystemCoreClock, 19200);
	if(status == MD_ERROR)
	{
		while(1);	// The baud rate cannot get at the current system clock frequency.
	}
	
	printf("Hello, UART\n");
#endif


	
//	printf("IICA Slave test BEGIN...\n");
//-----------------------------------------------------------------------
// IICA Single Master transmission/reception
//----------------------------------------------------------------------- 
#if 0
	printf("\n");	
	printf("Please connect No.34 pin(PD00/SCLA0) to SCL on partner board\n");
	printf("Please connect No.33 pin(PD01/SDAA0) to SDA on partner board\n");
	printf("Press any key to continue\n");
	getchar();
	printf("\n");	
#endif
 
    IICA0_Init();
	for(;;)
	{
		IICA0_SlaveReceive(SLVADDR, buf, sizeof(buf));
		IICA0_SlaveSend(SLVADDR, buf, sizeof(buf));
		//IICA0_Set_Wakeup(); /* Entry DeepSleep and waiting wakeup */
		while(g_iica0_rx_end == 0);
		while(g_iica0_tx_end == 0);
	}
}
/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}

