/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include <string.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "sci.h"
#include "clk.h"
#include "rtc.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
static volatile uint32_t g_ticks;
void SysTick_Handler(void);


int main()
{
	MD_STATUS status;
	uint32_t i;
	
//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#if 1
	SystemCoreClockUpdate();
	status = UART_Init(SCI0, SystemCoreClock, 19200);
	if(status == MD_ERROR)
	{
		while(1);
	}
	
	printf("Hello, UART\n");
#endif

//-----------------------------------------------------------------------
// 15bits IntervalTimer (Operation Clock: fIL)
//-----------------------------------------------------------------------
	printf("IntervalTimer operates with fIL\n");
	IT_Init(RTC_FIL, 1000);//
	IT_Start();

	for(i=0; i<8; i++)
	{	
		__STOP();  	/* Deep Sleep */
		printf("Wake up from deep sleep by 15bit IntervalTimer interrupt: No.%02d\n", g_ItIntTaken);
	}
	
	IT_Stop();

//-----------------------------------------------------------------------
// 15bits IntervalTimer (Operation Clock: fSUB)
//-----------------------------------------------------------------------	
	printf("IntervalTimer operates with fSUB\n");
	/* SubOSC ON */
	CLK_SubOsc_Setting(OSC_OSCILLATOR, OSC_LOW_POWER);
	IT_Init(RTC_FSUB, 2000);
	IT_Start();

	for(i=0; i<8; i++)
	{	
		__STOP();  	/* Deep Sleep */
		printf("Wake up from deep sleep by 15bit IntervalTimer interrupt: No.%02d\n", g_ItIntTaken);
	}
	
	IT_Stop();
}
/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}
