/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G179
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/
#pragma clang diagnostic ignored "-Wunused-parameter"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wcomment"


/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G439.h"
#include "userdefine.h"
#include "intp.h"
#include "sci.h"
#include "wdt.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
volatile uint32_t g_ticks;

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}

int main()
 {
	MD_STATUS status;
	uint32_t i;
	
    NVIC_EnableIRQ (WDT0_IRQn);
    PORT->PMC  &= ~0x4800;  // PC14,PC11 output mode
    *((volatile uint16_t *)(0x40021c20)) = 0xF160;

//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
//	SystemCoreClockUpdate();
//	status = UART_Init(SCI0, SystemCoreClock, 19200);
//	if(status == MD_ERROR)
//	{
//		while(1); // The baud rate cannot get at the current system clock frequency.
//	}

    PORT->PSETC = 0x4800;   // PC14,PC11 output "H"

//	printf("Hello, UART\n");
//	printf("RESF=%02x\n",RST->RESF);

//-----------------------------------------------------------------------
// Configure Option Byte C0H to enable WDT in system_.c
//-----------------------------------------------------------------------
//	for(i=0; i<8; i++)
//	{	
//		__HALT();  	/* Sleep */
////		printf("Wake up from sleep by WDT interrupt: No.%02d\n", g_WdtIntTaken);
//	}
    INTP_Init(0x01,INTP_FALLING);
    INTP_Start(0x01);
 	
	for(i=0; i<8; i++)
	{	
		__STOP();  	/* Deep Sleep */
//		printf("Wake up from deep sleep by WDT interrupt: No.%02d\n", g_WdtIntTaken);
	}	

    while(1){}
}

/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}


